'SetFocus and Overlapping Controls 
'(Jan. 28, 2001)
'By Achilles Mina

'This demonstrates the use of the SetFocus API call to change focus and
'also demonstrates how to deal with overlapping controls.

'You can do as you please with this code.

DECLARE FUNCTION Setfocus Lib "user32" Alias "SetFocus"(hwnd As Long) As Long

DECLARE SUB FocusEdit
DECLARE SUB FocusButton1
DECLARE SUB FocusButton2
DECLARE SUB B1Clicked
DECLARE SUB B2Clicked

CREATE Form AS QFORM
  Center
  CREATE Main AS QMAINMENU
    CREATE MainOption AS QMENUITEM
      Caption = "Option"
      CREATE Option1 AS QMENUITEM
        Caption = "Focus on Edit"
        OnClick = FocusEdit
      END CREATE
      CREATE Option2 AS QMENUITEM
        Caption = "Focus on Button1"
        OnClick = FocusButton1
      END CREATE
      CREATE Option3 AS QMENUITEM
        Caption = "Focus on Button2"
        OnClick = FocusButton2
      END CREATE
    END CREATE
  END CREATE
  CREATE Edit AS QEDIT
    Top = 20
    Left = 135
  END CREATE
  CREATE Button1 AS QBUTTON
    Caption = "Button1"
    Top = 70
    Left = 50
    OnClick = B1Clicked
  END CREATE
  CREATE Button2 AS QBUTTON
    Caption = "Button2"
    Top = 70
    Left = 50
    Visible = 0
    OnClick = B2Clicked
  END CREATE
  CREATE Label AS QLABEL
    Caption = "< Button2 is now UNDER Button1"
    Top = 75
    Left = 135
  END CREATE
END CREATE

SUB B1Clicked
  Button2.Visible = 1
  Label.Caption = "< Button1 is now UNDER Button2"
END SUB

SUB B2Clicked
  Button2.Visible = 0
  Label.Caption = "< Button2 is now UNDER Button1"
END SUB

SUB FocusEdit
  SetFocus(Edit.Handle)
END SUB

SUB FocusButton1
  SetFocus(Button1.Handle)
END SUB

SUB FocusButton2
  SetFocus(Button2.Handle)
END SUB

Form.ShowModal
